#include <stdio.h>

#define TRUE (1)
#define FALSE (0)
#define ESC          '\033'
#define PS_KANJI_IN  "\\377\\001"
#define PS_ASCII_IN  "\\377\\000"

#define octout(code) fprintf(stdout, "\\%03o", (code))
#define Error fprintf(stderr, "pcal: error in calendar file\n");exit(1)

/*
 * ConvertString -
 *   Plain JIS code string to Composite PostScript String.
 *   Special characters '(', ')', and '\' are converted to
 *   "\(", "\)", and "\\" respectively.
 *
 *   Special thanks to rihei@inagaki.nuie.nagoya-u.ac.jp
 */

void ConvertString(jis_str)
     char *jis_str;
{
  char c, c1, c2, c3;
  int kanjiflag = FALSE;

  while (*jis_str != NULL) {
    if (*jis_str == '\033') {
      jis_str++;
      if ((*jis_str == '$' && *(jis_str + 1) == '@') ||
	  (*jis_str == '$' && *(jis_str + 1) == 'B')) {
	kanjiflag = TRUE;
	printf("%s",PS_KANJI_IN);
	jis_str++;
	jis_str++;
      } else if ((*jis_str == '(' && *(jis_str + 1) == 'J') ||
		 (*jis_str == '(' && *(jis_str + 1) == 'B')) {
	kanjiflag = FALSE;
	if (*(jis_str + 2) != NULL) printf("%s",PS_ASCII_IN);
	jis_str++;
	jis_str++;
      } else {
	Error;
      }
    } else {
      if (kanjiflag)
	octout(*jis_str);
      else {
	switch (*jis_str) {
	case '(' : printf("\\("); break;
	case ')' : printf("\\)"); break;
	case '\\' : printf("\\\\"); break;
	case '\t': putchar(' '); break;
	default:
	  putchar(*jis_str); break;
	}
      }
      jis_str++;
    }
  }
}

